Subject: Re: Big Endian PCI driver

From: Stephen Hemminger <[email-masked]>
Date: Wed, 1 Nov 2006 21:15:58 -0800

On Thu, 2 Nov 2006 10:37:20 +0530
"Patel, Shalin" <[email-masked]> wrote:

> 
> Hi, 
> 
> I am trying to run PCI based Ethernet card (RTL 8139) on a big endian
> host. 
> 
> The pci controller that I have does not have any mechanism for swapping
> the Big Endian data to Little Endian. While running the 8139too.c driver
> I see that the data generated on the line is Endian swapped. 
> 
> In the data sheet of RTL 8139 I could not find any BSWAP bit neither the
> 8139too.c driver does any swapping of data while transmitting or
> receiving. However, if I change the driver to swap data before
> transmitting and after receiving I am able to get it working.
> 
> Does the RTL 8139 driver in 2.6.10 support Big Endian? Is there any
> other Ethernet card driver which supports big endian host (with a PCI
> controller which does not support byte swapping)?
> 
> Thanks,
> Shalin Patel

Skge does the byte swapping in hardware on the card.
Sky2 it was easier to do the byte swapping in software. It isn't hard
to do it in software.